Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1)
@@ -0,0 +1,316 @@
+ SUBROUTINE boundary_conds( range )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: boundary_conds.f90,v $
+! Revision 1.15  2006/02/23 09:54:55  raasch
+! Surface boundary conditions in case of topography: nzb replaced by
+! 2d-k-index-arrays (nzb_w_inner, etc.). Conditions for u and v remain
+! unchanged (still using nzb) because a non-flat topography must use a
+! Prandtl-layer, which don't requires explicit setting of the surface values.
+!
+! Revision 1.14  2005/06/29 09:49:40  steinfeld
+! Baroclinicity considered in the Dirichlet boundary condition for u and v at
+! the top boundary
+!
+! Revision 1.13  2005/04/23 08:35:30  raasch
+! Error removed in Dirichlet bottom boundary conditions for pt and q in case
+! of Runge-Kutta schemes. So far, new surface values have been taken from
+! timelevel t-dt, which does not exist in case of Runge-Kutta schemes.
+!
+! Revision 1.12  2005/03/26 14:58:24  raasch
+! Non-cyclic boundary conditions included, argument range added
+!
+! Revision 1.11  2001/03/30 06:54:18  raasch
+! Timelevel t+dt replaced by timelevel t,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.10  2001/01/29 12:19:27  raasch
+! Passive scalar is considered
+!
+! Revision 1.9  2001/01/22 05:25:56  raasch
+! Module test_variables removed
+!
+! Revision 1.8  2000/07/04 14:07:59  raasch
+! Missing diriclet boundary conditions for temperature and total water
+! content added
+!
+! Revision 1.7  2000/04/13 13:56:05  schroeter
+! Boundaray conditions for total water content
+!
+! Revision 1.6  2000/01/20  10:44:48  10:44:48  letzel (Marcus Letzel)
+! All comments translated into English
+! 
+! Revision 1.5  2000/01/10 09:28:53  raasch
+! Variablenuebergabe jetzt per Modul
+! Randbedingungen fuer w im Rahmen der pointer-Einfuehrung
+!
+! Revision 1.4  1998/07/06 12:07:05  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/03/10 07:19:37  raasch
+! Beschreibung ergaenzt um Randbedingung fuer TKE
+!
+! Revision 1.2  1997/09/19 07:39:03  raasch
+! Randbedingungen fuer TKE
+!
+! Revision 1.1  1997/09/12 06:21:34  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Boundary conditions for the prognostic quantities (range='main').
+! In case of non-cyclic lateral boundaries the conditions for velocities at
+! the outflow are set after the pressure solver has been called (range=
+! 'outflow_uvw').
+! One additional bottom boundary condition is applied for the TKE (=(u*)**2)
+! in prandtl_fluxes. The cyclic lateral boundary conditions are implicitly
+! handled in routine exchange_horiz. Pressure boundary conditions are
+! explicitly set in routines pres, poisfft, poismg and sor.
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE control_parameters
+    USE grid_variables
+    USE indices
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  range
+
+    INTEGER ::  i, j, k
+
+
+    IF ( range == 'main')  THEN
+!
+!--    Bottom boundary
+       IF ( ibc_uv_b == 0 )  THEN
+          u(nzb,:,:) = -u(nzb+1,:,:)  ! satisfying the Dirichlet condition with
+          v(nzb,:,:) = -v(nzb+1,:,:)  ! an extra layer below the surface where
+       ELSE                           ! the u and v component change their sign
+          u(nzb,:,:) = u(nzb+1,:,:)
+          v(nzb,:,:) = v(nzb+1,:,:)
+       ENDIF
+       DO  i = nxl-1, nxr+1
+          DO  j = nys-1, nyn+1
+             w(nzb_w_inner(j,i),j,i) = 0.0
+          ENDDO
+       ENDDO
+
+!
+!--    Top boundary
+       IF ( ibc_uv_t == 0 )  THEN
+          u(nzt+1,:,:) = ug(nzt+1)
+          v(nzt+1,:,:) = vg(nzt+1)
+       ELSE
+          u(nzt+1,:,:) = u(nzt,:,:)
+          v(nzt+1,:,:) = v(nzt,:,:)
+       ENDIF
+       w(nzt:nzt+1,:,:) = 0.0  ! nzt is not a prognostic level (but cf. pres)
+
+!
+!--    Temperature at bottom boundary
+       IF ( ibc_pt_b == 0 )  THEN
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   pt(nzb_s_inner(j,i),j,i) = pt_m(nzb_s_inner(j,i),j,i)
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   pt(nzb_s_inner(j,i),j,i) = pt_p(nzb_s_inner(j,i),j,i)  
+                                            ! pt_m is not used for Runge-Kutta
+                ENDDO
+             ENDDO
+          ENDIF
+       ELSE
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                pt(nzb_s_inner(j,i),j,i) = pt(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
+          ENDDO
+       ENDIF
+
+!
+!--    Temperature at top boundary
+       IF ( ibc_pt_t == 1 )  THEN
+          pt(nzt,:,:)   = pt(nzt-1,:,:) + bc_pt_t_val * dzu(nzt)
+          pt(nzt+1,:,:) = pt(nzt,:,:)   + bc_pt_t_val * dzu(nzt+1)
+       ENDIF
+
+!
+!--    Boundary conditions for TKE
+!--    Generally Neumann conditions with de/dz=0 are assumed
+       IF ( .NOT. constant_diffusion )  THEN
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                e(nzb_s_inner(j,i),j,i) = e(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
+          ENDDO
+          e(nzt,:,:)   = e(nzt-1,:,:)
+          e(nzt+1,:,:) = e(nzt,:,:)
+       ENDIF
+
+!
+!--    Boundary conditions for total water content or scalar,
+!--    bottom and surface boundary (see also temperature)
+       IF ( moisture  .OR.  passive_scalar )  THEN
+!
+!--       Surface conditions for constant_moisture_flux
+          IF ( ibc_q_b == 0 ) THEN
+             IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      q(nzb_s_inner(j,i),j,i) = q_m(nzb_s_inner(j,i),j,i)
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      q(nzb_s_inner(j,i),j,i) = q_p(nzb_s_inner(j,i),j,i)
+                   ENDDO                      ! q_m is not used for Runge-Kutta
+                ENDDO
+             ENDIF
+          ELSE
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   q(nzb_s_inner(j,i),j,i) = q(nzb_s_inner(j,i)+1,j,i)
+                ENDDO
+             ENDDO
+          ENDIF
+!
+!--       Top boundary
+          q(nzt,:,:)   = q(nzt-1,:,:) + bc_q_t_val * dzu(nzt)
+          q(nzt+1,:,:) = q(nzt,:,:)   + bc_q_t_val * dzu(nzt+1)
+       ENDIF
+
+!
+!--    Lateral boundary conditions at the inflow. Quasi Neumann conditions
+!--    are needed for the wall normal velocity in order to ensure zero
+!--    divergence. Dirichlet conditions are used for all other quantities.
+       IF ( inflow_s )  THEN
+          v(:,nys,:) = v(:,nys-1,:)
+       ELSEIF ( inflow_n ) THEN
+          v(:,nyn+vynp,:) = v(:,nyn+vynp+1,:)
+       ELSEIF ( inflow_l ) THEN
+          u(:,:,nxl) = u(:,:,nxl-1)
+       ELSEIF ( inflow_r ) THEN
+          u(:,:,nxr+uxrp) = u(:,:,nxr+uxrp+1)
+       ENDIF
+
+!
+!--    Lateral boundary conditions for scalar quantities at the outflow
+       IF ( outflow_s )  THEN
+          pt(:,nys-1,:)     = pt(:,nys,:)
+          IF ( .NOT. constant_diffusion     )  e(:,nys-1,:) = e(:,nys,:)
+          IF ( moisture .OR. passive_scalar )  q(:,nys-1,:) = q(:,nys,:)
+       ELSEIF ( outflow_n )  THEN
+          pt(:,nyn+1,:)     = pt(:,nyn,:)
+          IF ( .NOT. constant_diffusion     )  e(:,nyn+1,:) = e(:,nyn,:)
+          IF ( moisture .OR. passive_scalar )  q(:,nyn+1,:) = q(:,nyn,:)
+       ELSEIF ( outflow_l )  THEN
+          pt(:,:,nxl-1)     = pt(:,:,nxl)
+          IF ( .NOT. constant_diffusion     )  e(:,:,nxl-1) = e(:,:,nxl)
+          IF ( moisture .OR. passive_scalar )  q(:,:,nxl-1) = q(:,:,nxl)      
+       ELSEIF ( outflow_r )  THEN
+          pt(:,:,nxr+1)     = pt(:,:,nxr)
+          IF ( .NOT. constant_diffusion     )  e(:,:,nxr+1) = e(:,:,nxr)
+          IF ( moisture .OR. passive_scalar )  q(:,:,nxr+1) = q(:,:,nxr)
+       ENDIF
+
+    ENDIF
+
+    IF ( range == 'outflow_uvw' ) THEN
+!
+!--    Horizontal boundary conditions for the velocities at the outflow.
+!--    A Neumann condition is used for the wall normal velocity. The vertical
+!--    velocity is assumed as zero and a horizontal average along the wall is
+!--    used for the wall parallel horizontal velocity. The combination of all
+!--    three conditions ensures that the velocity field is free of divergence
+!--    at the outflow (uvmean_outflow_l is calculated in pres).
+       IF ( outflow_s ) THEN
+          v(:,nys-1,:) = v(:,nys,:)
+          w(:,nys-1,:) = 0.0
+!
+!--       Compute the mean horizontal wind parallel to and within the outflow
+!--       wall and use this as boundary condition for u
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( uvmean_outflow_l, uvmean_outflow, nzt-nzb+2, &
+                              MPI_REAL, MPI_SUM, comm1dx, ierr )
+          uvmean_outflow = uvmean_outflow / ( nx + 1.0 )
+#else
+          uvmean_outflow = uvmean_outflow_l / ( nx + 1.0 )
+#endif
+          DO  k = nzb, nzt+1
+             u(k,nys-1,:) = uvmean_outflow(k)
+          ENDDO
+       ENDIF
+
+       IF ( outflow_n ) THEN
+          v(:,nyn+vynp+1,:) = v(:,nyn+vynp,:)
+          w(:,nyn+1,:)      = 0.0
+!
+!--       Compute the mean horizontal wind parallel to and within the outflow
+!--       wall and use this as boundary condition for u
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( uvmean_outflow_l, uvmean_outflow, nzt-nzb+2, &
+                              MPI_REAL, MPI_SUM, comm1dx, ierr )
+          uvmean_outflow = uvmean_outflow / ( nx + 1.0 )
+#else
+          uvmean_outflow = uvmean_outflow_l / ( nx + 1.0 )
+#endif
+          DO  k = nzb, nzt+1
+             u(k,nyn+1,:) = uvmean_outflow(k)
+          ENDDO
+       ENDIF
+
+       IF ( outflow_l ) THEN
+          u(:,:,nxl-1) = u(:,:,nxl)
+          w(:,:,nxl-1) = 0.0
+!
+!--       Compute the mean horizontal wind parallel to and within the outflow
+!--       wall and use this as boundary condition for v
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( uvmean_outflow_l, uvmean_outflow, nzt-nzb+2, &
+                              MPI_REAL, MPI_SUM, comm1dy, ierr )
+          uvmean_outflow = uvmean_outflow / ( ny + 1.0 )
+#else
+          uvmean_outflow = uvmean_outflow_l / ( ny + 1.0 )
+#endif
+          DO  k = nzb, nzt+1
+             v(k,:,nxl-1) = uvmean_outflow(k)
+          ENDDO    
+
+       ENDIF
+
+       IF ( outflow_r ) THEN
+          u(:,:,nxr+uxrp+1) = u(:,:,nxr+uxrp)
+          w(:,:,nxr+1) = 0.0
+!
+!--       Compute the mean horizontal wind parallel to and within the outflow
+!--       wall and use this as boundary condition for v
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( uvmean_outflow_l, uvmean_outflow, nzt-nzb+2, &
+                              MPI_REAL, MPI_SUM, comm1dy, ierr )
+          uvmean_outflow = uvmean_outflow / ( ny + 1.0 )
+#else
+          uvmean_outflow = uvmean_outflow_l / ( ny + 1.0 )
+#endif
+          DO  k = nzb, nzt+1
+             v(k,:,nxr+1) = uvmean_outflow(k)
+          ENDDO    
+       ENDIF
+
+    ENDIF
+
+ 
+ END SUBROUTINE boundary_conds
Index: palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- palm/trunk/SOURCE/buoyancy.f90	(revision 4901)
+++ palm/trunk/SOURCE/buoyancy.f90	(revision 1)
@@ -1,38 +1,73 @@
-!> @file buoyancy.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
+ MODULE buoyancy_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-!
-! 3725 2019-02-07 10:11:02Z raasch
-! unused variables removed
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! nopointer option removed
+! $Log: buoyancy.f90,v $
+! Revision 1.19  2006/04/26 12:09:56  raasch
+! OpenMP optimization (one dimension added to sums_l)
+!
+! Revision 1.18  2006/02/23 09:55:33  raasch
+! nzb_2d replaced by nzb_s_inner/outer, nanz_2dh(0) replaced by
+! ngp_2dh_outer(:,0)
+!
+! Revision 1.17  2005/12/06 15:29:16  raasch
+! Mean pt profile is calculated only in case of the first intermediate timestep
+!
+! Revision 1.16  2004/01/30 10:14:31  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.15  2003/10/29 08:41:47  raasch
+! Horizontal mean temperature is now taken from array hom instead of array sums
+!
+! Revision 1.14  2003/03/16 09:27:22  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.13  2003/03/12 16:20:47  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.12  2002/12/19 13:47:38  raasch
+! STOP statement replaced by call of subroutine local_stop
+!
+! Revision 1.11  2002/06/11 12:33:07  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+! Calculation of the horizontally averaged temperature profile moved to new
+! subroutine calc_mean_pt_profile, which is part of this module.
+!
+! Revision 1.10  2001/03/30 06:54:56  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.9  2001/01/22 05:27:03  raasch
+! Module test_variables removed
+!
+! Revision 1.8  2000/07/03 12:55:56  raasch
+! Argument theta declared as pointer
+!
+! Revision 1.7  2000/04/27 07:04:19  raasch
+! in case of a sloping surface the temperature difference is computed relative
+! to the initial (2D) temperature field
+!
+! Revision 1.6  2000/04/13 14:27:34  schroeter
+! considering the influence of humidity to the buoyancy term
+! (only for sloping_surface = false),
+!
+! Revision 1.5  2000/01/21  16:17:23  16:17:23  letzel (Marcus Letzel)
+! All comments translated into English
+! 
+! Revision 1.4  1998/09/22 17:16:22  raasch
+! Auftriebsterm erweitert fuer Rechnungen mit geneigter Ebene
+!
+! Revision 1.3  1998/07/06 12:07:27  raasch
+! + USE test_variables
+!
+! Revision 1.2  1998/03/30 11:33:29  raasch
+! nanz_2dh in nanz_2dh(0) geaendert
 !
 ! Revision 1.1  1997/08/29 08:56:48  raasch
@@ -42,23 +77,10 @@
 ! Description:
 ! ------------
-!> Buoyancy term of the third component of the equation of motion.
-!> @attention Humidity is not regarded when using a sloping surface!
-!--------------------------------------------------------------------------------------------------!
- MODULE buoyancy_mod
-
-    USE basic_constants_and_equations_mod,                                                         &
-        ONLY:  g
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  pt, pt_slope_ref, ref_state, tend
-
-    USE control_parameters,                                                                        &
-        ONLY:  atmos_ocean_sign, cos_alpha_surface, message_string, pt_surface, sin_alpha_surface, &
-               sloping_surface
-
-    USE kinds
+! Buoyancy term of the third component of the equation of motion.
+! WARNING: humidity is not regarded when using a sloping surface!
+!------------------------------------------------------------------------------!
 
     PRIVATE
-    PUBLIC buoyancy
+    PUBLIC buoyancy, calc_mean_pt_profile
 
     INTERFACE buoyancy
@@ -67,26 +89,26 @@
     END INTERFACE buoyancy
 
+    INTERFACE calc_mean_pt_profile
+       MODULE PROCEDURE calc_mean_pt_profile
+    END INTERFACE calc_mean_pt_profile
+
  CONTAINS
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
-    SUBROUTINE buoyancy( var, wind_component )
-
-       USE indices,                                                                                &
-           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzt
-
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE buoyancy( theta, wind_component, pr )
+
+       USE arrays_3d
+       USE control_parameters
+       USE indices
+       USE pegrid
+       USE statistics
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i              !<
-       INTEGER(iwp) ::  j              !<
-       INTEGER(iwp) ::  k              !<
-       INTEGER(iwp) ::  wind_component !<
-
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  var
+       INTEGER ::  i, j, k, pr, wind_component
+       REAL, DIMENSION(:,:,:), POINTER  ::  theta
 
 
@@ -94,16 +116,11 @@
 !
 !--       Normal case: horizontal surface
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-          !$ACC PRESENT(var) &
-          !$ACC PRESENT(ref_state) &
-          !$ACC PRESENT(tend)
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb+1, nzt-1
-                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp *                     &
-                                 (                                                                 &
-                                    ( var(k,j,i)   - ref_state(k) )   / ref_state(k) +             &
-                                    ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1)             &
-                                 )
+                DO  k = nzb_s_inner(j,i)+1, nzt-1
+                    tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                    &
+                        ( theta(k,j,i)   - hom(k,1,pr,0)   ) / hom(k,1,pr,0) + &
+                        ( theta(k+1,j,i) - hom(k+1,1,pr,0) ) / hom(k+1,1,pr,0) &
+                                                          )
                 ENDDO
              ENDDO
@@ -112,18 +129,18 @@
        ELSE
 !
-!--       Buoyancy term for a surface with a slope in x-direction. The equations for both the u and
-!         w velocity-component contain proportionate terms.
+!--       Buoyancy term for a surface with a slope in x-direction. The equations
+!--       for both the u and w velocity-component contain proportionate terms.
 !--       Temperature field at time t=0 serves as environmental temperature.
-!--       Reference temperature (pt_surface) is the one at the lower left corner of the total
-!--       domain.
+!--       Reference temperature (pt_surface) is the one at the lower left corner
+!--       of the total domain.
           IF ( wind_component == 1 )  THEN
 
-             DO  i = nxlu, nxr
+             DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb+1, nzt-1
-                      tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *                          &
-                                    0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         )         &
-                                             - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) )         &
-                                             ) / pt_surface
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *      &
+                           0.5 * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
+                                 - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
+                                 ) / pt_surface
                    ENDDO
                 ENDDO
@@ -134,9 +151,9 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb+1, nzt-1
-                      tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *                          &
-                                    0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         )         &
-                                             - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) )         &
-                                             ) / pt_surface
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *      &
+                           0.5 * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
+                                 - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
+                                 ) / pt_surface
                    ENDDO
                 ENDDO
@@ -145,6 +162,7 @@
           ELSE
 
-             WRITE( message_string, * ) 'no term for component "', wind_component, '"'
-             CALL message( 'buoyancy', 'PA0159', 1, 2, 0, 6, 0 )
+             IF ( myid == 0 )  PRINT*, '+++ buoyancy: no term for component "',&
+                                       wind_component,'"'
+             CALL local_stop
 
           ENDIF
@@ -155,73 +173,135 @@
 
 
-!--------------------------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE buoyancy_ij( i, j, theta, wind_component, pr )
+
+       USE arrays_3d
+       USE control_parameters
+       USE indices
+       USE pegrid
+       USE statistics
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k, pr, wind_component
+       REAL, DIMENSION(:,:,:), POINTER  ::  theta
+
+
+       IF ( .NOT. sloping_surface )  THEN
+!
+!--       Normal case: horizontal surface
+          DO  k = nzb_s_inner(j,i)+1, nzt-1
+              tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                          &
+                        ( theta(k,j,i)   - hom(k,1,pr,0)   ) / hom(k,1,pr,0) + &
+                        ( theta(k+1,j,i) - hom(k+1,1,pr,0) ) / hom(k+1,1,pr,0) &
+                                                    )
+          ENDDO
+
+       ELSE
+!
+!--       Buoyancy term for a surface with a slope in x-direction. The equations
+!--       for both the u and w velocity-component contain proportionate terms.
+!--       Temperature field at time t=0 serves as environmental temperature.
+!--       Reference temperature (pt_surface) is the one at the lower left corner
+!--       of the total domain.
+          IF ( wind_component == 1 )  THEN
+
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+                tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *            &
+                           0.5 * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
+                                 - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
+                                 ) / pt_surface
+             ENDDO
+
+          ELSEIF ( wind_component == 3 )  THEN
+
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+                tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *            &
+                           0.5 * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
+                                 - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
+                                 ) / pt_surface
+             ENDDO
+
+          ELSE
+
+             IF ( myid == 0 )  PRINT*, '+++ buoyancy: no term for component "',&
+                                       wind_component,'"'
+             CALL local_stop
+
+          ENDIF
+
+       ENDIF
+
+    END SUBROUTINE buoyancy_ij
+
+
+    SUBROUTINE calc_mean_pt_profile( theta, pr )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Call for grid point i,j
-!> @attention PGI-compiler creates SIGFPE if opt>1 is used! Therefore, opt=1 is forced by
-!>            compiler-directive.
-!--------------------------------------------------------------------------------------------------!
-!pgi$r opt=1
-    SUBROUTINE buoyancy_ij( i, j, var, wind_component )
-
-
-       USE indices,                                                                                &
-           ONLY:  nzb, nzt
+! Calculate the horizontally averaged vertical temperature profile (pr=4 in case
+! of potential temperature and 44 in case of virtual potential temperature).
+!------------------------------------------------------------------------------!
+
+       USE control_parameters
+       USE indices
+       USE pegrid
+       USE statistics
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i              !<
-       INTEGER(iwp) ::  j              !<
-       INTEGER(iwp) ::  k              !<
-       INTEGER(iwp) ::  wind_component !<
-
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  var
-
-
-       IF ( .NOT. sloping_surface )  THEN
-!
-!--       Normal case: horizontal surface
-          DO  k = nzb+1, nzt-1
-              tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp * (                        &
-                            ( var(k,j,i)   - ref_state(k)   ) / ref_state(k)   +                   &
-                            ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1)                     &
-                                                                          )
+       INTEGER ::  i, j, k, omp_get_thread_num, pr, tn
+       REAL, DIMENSION(:,:,:), POINTER  ::  theta
+
+!
+!--    Computation of the horizontally averaged temperature profile, unless
+!--    already done by the relevant call from flow_statistics. The calculation
+!--    is done only for the first respective intermediate timestep in order to
+!--    spare communication time and to produce identical model results with jobs
+!--    which are calling flow_statistics at different time intervals.
+!--    Although this calculation is not required for model runs with a slope,
+!--    it is nevertheless also computed.
+       IF ( .NOT. flow_statistics_called  .AND. &
+            intermediate_timestep_count == 1 )  THEN
+
+!
+!--       Horizontal average of the potential temperature
+          tn           =   0  ! Default thread number in case of one thread
+          !$OMP PARALLEL PRIVATE( i, j, k, tn )
+!$        tn = omp_get_thread_num()
+          sums_l(:,pr,tn) = 0.0
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j =  nys, nyn
+                DO  k = nzb_s_outer(j,i), nzt+1
+                   sums_l(k,pr,tn) = sums_l(k,pr,tn) + theta(k,j,i)
+                ENDDO
+             ENDDO
           ENDDO
-
-       ELSE
-!
-!--       Buoyancy term for a surface with a slope in x-direction. The equations for both the u and
-!--       w velocity-component contain proportionate terms.
-!--       Temperature field at time t=0 serves as environmental temperature.
-!--       Reference temperature (pt_surface) is the one at the lower left corner of the total
-!--       domain.
-          IF ( wind_component == 1 )  THEN
-
-             DO  k = nzb+1, nzt-1
-                tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *                                &
-                              0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         )               &
-                                       - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) )               &
-                                       ) / pt_surface
-             ENDDO
-
-          ELSEIF ( wind_component == 3 )  THEN
-
-             DO  k = nzb+1, nzt-1
-                tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *                                &
-                              0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         )               &
-                                       - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) )               &
-                                       ) / pt_surface
-             ENDDO
-
-          ELSE
-
-             WRITE( message_string, * ) 'no term for component "', wind_component, '"'
-             CALL message( 'buoyancy', 'PA0159', 1, 2, 0, 6, 0 )
-
-          ENDIF
+          !$OMP END PARALLEL
+
+          DO  i = 1, threads_per_task-1
+             sums_l(:,pr,0) = sums_l(:,pr,0) + sums_l(:,pr,i)
+          ENDDO
+
+#if defined( __parallel )
+
+          CALL MPI_ALLREDUCE( sums_l(nzb,pr,0), sums(nzb,pr), nzt+2-nzb, &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
+
+#else
+
+          sums(:,pr) = sums_l(:,pr,0)
+
+#endif
+
+          hom(:,1,pr,0) = sums(:,pr) / ngp_2dh_outer(:,0)
 
        ENDIF
 
-    END SUBROUTINE buoyancy_ij
+    END SUBROUTINE calc_mean_pt_profile
 
  END MODULE buoyancy_mod
